#!/bin/sh
#set -x
#
# ! Many thanks to Kindzadza, Ronald and Dr.Matrix for writing		!
# ! great EMU software and by doing so making Linux based receivers 	|
# ! the best in the world. Hope you guys continue to extend and improve ! 
# ! your software for a long time! Thanks!				!
#
# dreamconv.sh - convert between several emu key formats
#
# History:
#
# v2.3.5 - 10-03-2005 - noleech
#  - added: conversion from SoftCam.Key to camd3.keys
#  - fixed: conversion from SoftCam.Key to scce
#
# v2.3.4 - 14-11-2003 - Tom0000
#  - added: conversion from softcam.key to scce
#  - fixed: conversion from scce->softcam.key, gbox->scce, scce->gbox
#
# v2.3.3 - 07-11-2003 - Tom0000
#  - added: conversion from keylist (newcamd) to softcam.key
#  - added: conversion from softcam.key to keylist (newcamd)
#      If you will find a bug, write about it: cattomcat@hotmail.com
#
# v2.3.2 - 07-11-2003 - Tom0000
#  - added: conversion from keys.txt (xcam) to softcam.key
#  - added: conversion from Keylist.txt (evocamd) to softcam.key
#  - added: conversion from softcam.key to Keylist.txt (evocamd)
#
# v2.3.1 - 23-10-2003 - Tom0000
# - added: conversion from gbox to softcam.key
# - fixed: conversion from softcam.key to gbox
#
# v2.3.0 - 23-08-2003 - noleech
# - added: romu key conversion (for now same as scce)
# - added: nozap key conversion (use mgcamd2romu with CardManie SoftCam.Key)
# - fixed: comments are converted again to x2romu, ROMU rules ;-)
# - fixed: gbox2emu Viaccess PMK conversion UNTESTED
#
# v2.2.2 - 29-05-2003 - noleech
# - rewrote mgcamd --> gbox nagra provider id hack
# - added star digital provider id hack
#
# v2.2.1 - 21-05-2003 - noleech
# - Thanks to MikeV@sat4all for testing!
# - added gbox <-> scce irdeto/seca/via pmk key conversion 
#   (not 100% sure about format and whether scce supports it yet)
# - fixed mgcamd/gbox --> scce now deletes all comment 
#   (otherwise scce complains about illegal characters)
#
# v2.1.1 - 18-05-2003 - noleech
# - fixed broken via_keys output in mgcamd2scce and gbox2scce
#
# v2.0 - 17-05-2003 - noleech
# - added mgcamd --> scce :)
# - added mgcamd --> gbox
# - added added nagravision provider hack
# - added nagra to gbox <-> scce
# - namechange to dreamconv.sh
# - added lots of comment
#
# v1.0 - 15-05-2003 - noleech
# - (called keyconvert.sh) initial version gbox <-> scce
# 
# o0O todo O0o
# - todo:  mgcamd2romu au lines?
# - todo:  file converted from $file at $date
# - todo:  x2gbox - keep PMKs
# - todo:  x2romu - keep PMKs
# - todo:  pmkgbox2romu - only convert PMKs
# - todo:  More suggestions? Mail me!
#
# Cheers to the sat4all members and all other Dreambox fans.
#
# If you add or change something to this script, please tell me so
# that I can learn from it: noleech@<remove>beschier.com
#
# MAKE SURE THE FOLLOWING PATHS ARE CORRECT!
#
# define the path and filenames of gbox keyfiles
GBOXIRDETO=/var/keys/irdeto
GBOXIRDETOTMP=/var/tmp/irdeto
GBOXNAGRA=/var/keys/nagra
GBOXNAGRATMP=/var/tmp/nagra
GBOXSECA=/var/keys/seca
GBOXSECATMP=/var/tmp/seca
GBOXVIA=/var/keys/via
GBOXVIATMP=/var/tmp/via
GBOXCONAX=/var/keys/conax
GBOXCONAXTMP=/var/tmp/conax

# define the path and filenames of scce keyfiles
SCCECONAX=/var/scce/conax_keys
SCCECONAXTMP=/var/tmp/conax_keys
SCCEIRDETO=/var/scce/irdeto_keys
SCCEIRDETOTMP=/var/tmp/irdeto_keys
SCCENAGRA=/var/scce/nagra_keys
SCCENAGRATMP=/var/tmp/nagra_keys
SCCENOZAP=/var/scce/nozap_keys
SCCENOZAPTMP=/var/tmp/nozap_keys
SCCESECA=/var/scce/seca_keys
SCCESECATMP=/var/tmp/seca_keys
SCCEVIA=/var/scce/via_keys
SCCEVIATMP=/var/tmp/via_keys
SCCENAGRARSA=/var/scce/nagra_rsa
SCCENAGRARSATMP=/var/tmp/nagra_rsa

# define path and filename of mgcamd keyfile
MGCAMD=/var/keys/SoftCam.Key
MGCAMDTMP=/var/tmp/SoftCam.Key
XCAM=/var/keys/keys.txt
XCAMTMP=/var/tmp/keys.txt
EVOCAMD=/var/keys/Keylist.txt
EVOCAMDTMP=/var/tmp/Keylist.txt
NEWCAMD=/var/scce/keylist
NEWCAMDTMP=/var/tmp/keylist
CAMD3=/var/keys/camd3.keys
CAMD3TMP=/var/tmp/camd3.keys
# define path and filename of mgcamd irdeto pmk/nagra rsa file
AUTOROLL=/var/keys/AutoRoll.Key

mgcamd2camd3()
{
echo "#*************************************************************************" > $CAMD3TMP
echo "# Created by dreamconv.sh from SoftCam.Key file" >> $CAMD3TMP
echo "#*************************************************************************" >> $CAMD3TMP
echo "# Nagravision keys" >> $CAMD3TMP
grep -e '^[Nn].[0-9][0-9][0-9][0-9]   [0-9][0-9]' $MGCAMD | sed -e 's/^[Nn] \(....\)   \(..\) \(................\)/1800:00\1:0000000000:\2:\3/' >> $CAMD3TMP
grep -e '^[Nn] [0-9][0-9][0-9][0-9] .. ' $MGCAMD | sed -e 's/^[Nn] \(....\) \(..\) \(.................................................................................................................................\)/1800:00\1:0000000000:\2:\3/' >> $CAMD3TMP
echo "# Viaccess keys" >> $CAMD3TMP
grep -e '^[Vv] \(......\) \(..\) \(................\) ' $MGCAMD | sed -e 's/^[Vv] \(......\) \(..\) \(................\)/0500:\1:0000000000:\2:\3/'  >> $CAMD3TMP
grep -e '^[Vv] \(......\) \(..\) \(................[0-9|a-z|A-Z]...............\) ' $MGCAMD | sed -e 's/^[Vv] \(......\) \(..\) \(................................\)/0500:\1:0000000000:\2:\3/' >> $CAMD3TMP
echo "# Seca keys" >> $CAMD3TMP
grep -e '^[Ss]' $MGCAMD | sed -e 's/^[Ss] \(....\)   \(..\) \(................\)/0100:00\1:0000000000:\2:\3/' >> $CAMD3TMP
echo "# Irdeto keys" >> $CAMD3TMP
grep -e '^[Ii]' $MGCAMD | sed -e 's/^[Ii] \(..\)     \(..\) \(................\)/0602:0000\1:0000000000:\2:\3/' >> $CAMD3TMP
grep -e '^[Ii]' $MGCAMD | sed -e 's/^[Ii] \(..\)     \(..\) \(................\)/1762:0000\1:0000000000:\2:\3/' >> $CAMD3TMP
cp $CAMD3TMP $CAMD3
}

gbox2scce()
{
# irdeto
  grep -e '^[MI]:' $GBOXIRDETOTMP | sed -e 's/^M: { \(..\) \(..\) \(..\) \(.*\)/M: { \1\2\3 \4/' > $SCCEIRDETO
# nagravision
  grep -e '^N:' $GBOXNAGRATMP | sed -e 's/^N: { \(..\) \(..\) \(.*\)/N: { \1\2 \3/' > $SCCENAGRA
# seca
  grep -e '^[MS]:' $GBOXSECATMP | sed -e 's/^S: { \(..\) \(.*\)/S: { \1\2/' -e 's/^M: { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(.*\)/M: { \1\2 \4\5\6 \7 \8/' > $SCCESECA
# viaccess
  grep -e '[MV]:' $GBOXVIATMP | sed -e 's/^M: { \(.\)\(.\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/M: { \2\3\4 \6\7\8/' -e 's/^M: { \(.....\) \(......\)\(..\)\(...\)\(.*\)/M: { \1 \2 \3\5/' -e 's/^V: { \(..\) \(..\) \(.\)\(.\) \(..\)\(.*\)/V: { \1\2\3 \5\6/' > $SCCEVIA
}

scce2gbox()
{
# irdeto
  grep -e '^[MI;]' $SCCEIRDETO | sed -e 's/^M: { \(..\)\(..\)\(..\)/M: { \1 \2 \3/' -e 's/^;/#/'  > $GBOXIRDETOTMP
  cp $GBOXIRDETOTMP $GBOXIRDETO
# nagravision
  grep -e '^[N;]' $SCCENAGRA | sed -e 's/^N: { \(..\)\(..\) \(.*\)/N: { \1 \2 \3/' -e 's/^;/#/' > $GBOXNAGRATMP
  cp $GBOXNAGRATMP $GBOXNAGRA
# seca
  grep -e '^[MS;]' $SCCESECA | sed -e 's/^S: { \(..\)\(.*\)/S: { \1 \2/' -e 's/^M: { \(..\)\(..\) \(..\)\(..\)\(..\) \(..\)\(.*\)/M: { \1 \2 00 \3 \4 \5 \6\7/' -e 's/^;/#/' > $GBOXSECATMP
  cp $GBOXSECATMP $GBOXSECA
# viaccess
  grep -e '^[MV;]' $SCCEVIA | sed -e 's/^V: { \(..\)\(..\)\(.\) \(.*\)/V: { \1 \2 \30 \4/' -e 's/^M: { \(..\)\(..\)\(..\) \(..\)\(..\)\(..\)\(.*\)/M: { 00 \1 \2 \3 00 \4 \5 \6\7/' -e 's/^;/#/' > $GBOXVIATMP
  cp $GBOXVIATMP $GBOXVIA
}

mgcamd2gbox()
{
# irdeto
  echo "# Conversion from softcam.key file to gbox files" > $GBOXIRDETOTMP
  grep -e '^MK\?:' $GBOXIRDETO >> $GBOXIRDETOTMP
  grep -e '^I' $MGCAMD | sed -e 's/^I \(..\)     \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/I: \{ \2 \{ \3 \4 \5 \6 \7 \8 \9 /' -e 's/^I: \({ .. { .. .. .. .. .. .. .. \)\(..\)/I: \1\2 }}/' -e 's/^I: { \(.. { .. .. .. .. .. .. .. .. \)\(}}[; ]*\)/I: { \1\2/' >> $GBOXIRDETOTMP
  cp $GBOXIRDETOTMP $GBOXIRDETO
# nagravision
  echo "# Conversion from softcam.key file to gbox files" > $GBOXNAGRATMP
  grep -e '^MK\?:' $GBOXNAGRA >> $GBOXNAGRATMP
  grep -e '^N' $MGCAMD | sed -e 's/^N \(..\)\(..\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/N: { \1 \2 \3 { \4 \5 \6 \7 \8 \9 /' -e 's/^N: { \(.. .. .. { .. .. .. .. .. ..\) \(..\)\(..\)/N: { \1 \2 \3 }}/' -e 's/^N: { \(.. .. .. { .. .. .. .. .. .. .. .. \)\(}}[; ]*\)/N: { \1\2/' >> $GBOXNAGRATMP
  cp $GBOXNAGRATMP $GBOXNAGRA
# seca
  echo "# Conversion from softcam.key file to gbox files" > $GBOXSECATMP
  grep -e '^MK\?:' $GBOXSECA >> $GBOXSECATMP
  grep -e '^S' $MGCAMD | sed -e 's/^S \(..\)\(..\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/S: { \1 \2 \3 { \4 \5 \6 \7 \8 \9 /' -e 's/^S: { \(.. .. .. { .. .. .. .. .. .. \)\(..\)\(..\)/S: { \1\2 \3 }}/' -e 's/^S: { \(.. .. .. { .. .. .. .. .. .. .. .. \)\(}}[; ]*\)/S: { \1\2/' >> $GBOXSECATMP
  cp $GBOXSECATMP $GBOXSECA
# viaccess
  echo "# Conversion from softcam.key file to gbox files" > $GBOXVIATMP
  grep -e '^MK\?:' $GBOXVIA >> $GBOXVIATMP
  grep -e '^V' $MGCAMD | sed -e 's/^V \(..\)\(..\)\(..\) \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)/V: { \1 \2 \3 \4 { \5 \6 \7 \8 \9 /' -e 's/^V: { \(.. .. .. .. { .. .. .. .. .. \)\(..\)\(..\)\(..\)/V: { \1\2 \3 \4 }}/' -e 's/^V: { \(.. .. .. .. { .. .. .. .. .. .. .. .. \)\(}}[; ]*\)/V: { \1\2/' >> $GBOXVIATMP
  cp $GBOXVIATMP $GBOXVIA
}

gbox2mgcamd()
{
echo "; SoftCam.Key generated by dreamconv.sh from gbox files" > $MGCAMDTMP
echo ";" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; IRDETO Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
  grep -e '^I' $GBOXIRDETOTMP | sed -e 's/^I: { \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/I 00     \1 \2\3\4\5\6\7\8\9 /' -e 's/^I 00     \(.. ................ \)\( }}[ ;#]\?[ ;#]\?[ ;#]\?\)\(.*\)/I 00     \1;\3/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; SECA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^S' $GBOXSECATMP | sed -e 's/^S: { \(..\) \(..\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/S \1\2   \3 \4\5\6\7\8\9/' -e 's/^S \(....   .. ............\) \(..\) \(..\)/S \1\2\3 /' -e 's/^S \(....   .. ................ \)\( }}[ ;#]\?[ ;#]\?[ ;#]\?\)\(.*\)/S \1;\3/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; VIACCESS Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^V' $GBOXVIATMP | sed -e 's/^V: { \(..\) \(..\) \(..\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\)/V \1\2\3 \4 \5\6\7\8\9/' -e 's/^V \(...... .. ..........\) \(..\) \(..\) \(..\)/V \1\2\3\4 /' -e 's/^V \(...... .. ................ \)\( }}[ ;#]\?[ ;#]\?[ ;#]\?\)\(.*\)/V \1;\3/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; NAGRA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^N' $GBOXNAGRATMP | sed -e 's/^N: { \(..\) \(..\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/N \1\2   \3 \4\5\6\7\8\9/' -e 's/^N \(....   .. ............\) \(..\) \(..\)/N \1\2\3 /' -e 's/^N \(....   .. ................ \)\( }}[ ;#]\?[ ;#]\?[ ;#]\?\)\(.*\)/N \1;\3/' >> $MGCAMDTMP
nagraunhack $MGCAMDTMP $MGCAMD
}  

mgcamd2scce()
{
# check for AutoRoll.Key; if exists create nagra_rsa
  if test -f $AUTOROLL
  then
    grep ^N $AUTOROLL > $SCCENAGRARSA
  fi

# irdeto
  echo "; Conversion from softcam.key file to scce files" > $SCCEIRDETOTMP
  [ -f $GBOXIRDETO ] && grep -e '^MK\?:' $GBOXIRDETO >> $SCCEIRDETOTMP
grep -e '^[Ii]' $MGCAMD | sed -e 's/^[Ii] \(..\)     \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/I: { \2 { \3 \4 \5 \6 \7 \8 \9 /' -e 's/^I: { \(..\) { \(.. .. .. .. .. .. ..\) \(..\)\([ ;#]\?[ ;#]\?\)\(.*\)/I: { \1 { \2 \3 }} #\5/' >> $SCCEIRDETOTMP
  mv $SCCEIRDETOTMP $SCCEIRDETO
# seca
  echo "; Conversion from softcam.key file to scce files" > $SCCESECATMP
  [ -f $GBOXSECA ] && grep -e '^MK\?:' $GBOXSECA >> $SCCESECATMP
  grep -e '^[Ss]' $MGCAMD | sed -e 's/^[Ss] \(....\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/S: { \1 \2 { \3 \4 \5 \6 \7 \8 \9 /' -e 's/^S: { \(.... .. { .. .. .. .. .. .. .. \)\(..\)\([ ;#]\?[ ;#]\?\)\(.*\)/S: { \1\2 }} #\4/' >> $SCCESECATMP
  mv $SCCESECATMP $SCCESECA
# viaccess
  echo "; Conversion from softcam.key file to scce files" > $SCCEVIATMP
  [ -f $GBOXVIA ] && grep -e '^MK\?:' $GBOXVIA >> $SCCEVIATMP
  grep -e '^[Vv]' $MGCAMD | sed -e 's/^[Vv] \(.....\)\(.\) \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/V: { \1 \3 { \4 \5 \6 \7 \8 \9 /' -e 's/^V: { \(..... .. { .. .. .. .. .. .. \)\(..\)\(..\)\([ ;#]\?[ ;#]\?\)\(.*\)/V: { \1\2 \3 }} #\5/' >> $SCCEVIATMP
  mv $SCCEVIATMP $SCCEVIA
# nagravision
  echo "; Conversion from softcam.key file to scce files" > $SCCENAGRATMP
  [ -f $GBOXNAGRA ] && grep -e '^MK\?:' $GBOXNAGRA >> $SCCENAGRATMP
  grep -e '^[Nn]' $MGCAMD | sed -e 's/^[Nn] \(....\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/N: { \1 \2 { \3 \4 \5 \6 \7 \8 \9 /' -e 's/^N: { \(.... .. { .. .. .. .. .. .. .. \)\(..\)\([ ;#]\?[ ;#]\?\)\(.*\)/N: { \1\2 }} #\4/' >> $SCCENAGRATMP
  mv $SCCENAGRATMP $SCCENAGRA
}


scce2mgcamd()
{
echo "; SoftCam.Key generated by dreamconv.sh from scce files (ucas)" > $MGCAMDTMP
echo ";" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; IRDETO Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
  grep -e '^[Ii]' $SCCEIRDETO | sed -e 's/^[Ii]: { \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/I 00     \1 \2\3\4\5\6\7\8\9 /' -e 's/^I 00     \(.. ................ \)\( }}[ ;#]\?[ ;#]\?\)\(.*\)/I 00     \1;\3/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; SECA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^[Ss]' $SCCESECA | sed -e 's/^[Ss]: { \(....\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/S \1   \2 \3\4\5\6\7\8/' -e 's/^S \(....   .. ............\) \(..\) \(..\)/S \1\2\3 /' -e 's/^S \(....   .. ................ \)\( }}[ ;#]\?[ ;#]\?\)\(.*\)/S \1;\3/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; VIACCESS Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^[Vv]' $SCCEVIA | sed -e 's/^[Vv]: { \(.....\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/V \10 \2 \3\4\5\6\7\8/' -e 's/^V \(...... .. ............\) \(..\) \(..\)/V \1\2\3 /' -e 's/^V \(...... .. ................ \)\( }}[ ;#]\?[ ;#]\?\)\(.*\)/V \1;\3/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; NAGRA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^[Nn]' $SCCENAGRA | sed -e 's/^[Nn]: { \(....\) \(..\) { \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/N \1   \2 \3\4\5\6\7\8/' -e 's/^N \(....   .. ............\) \(..\) \(..\)/N \1\2\3 /' -e 's/^N \(....   .. ................ \)\( }}[ ;#]\?[ ;#]\?\)\(.*\)/N \1;\3/' >> $MGCAMDTMP
nagraunhack $MGCAMDTMP $MGCAMD
}

xcam2mgcamd()
{
echo "; SoftCam.Key generated by dreamconv.sh from Keys.txt (xcam)" > $MGCAMDTMP
echo ";" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; IRDETO Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
tr "\r" " " < $XCAM | tr "\n" "^" | tr "[" "\n" | grep -e "^[iI].*[kK][eE][yY]" | sed -e "s/[iI]\(......\)]^[nN][aA][zZ][wW][aA]=\(.*\)^[hH][sS][nN]=......^[hH][mM][kK]=....................^[pP][mM][kK]=................^[mM][iI][dD]=\(..\)^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/I 00     \4 \5 ;\6 \2 ID=\1 mid=\3@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@^p:_/" -e "s/^\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/\1I 00     \2 \3 ;\4@/" -e "s/\^.*$/;--------------------------------------------------@;/" | tr "@" "\n" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; SECA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo ";" >> $MGCAMDTMP
tr "\r" " " < $XCAM | tr "\n" "^" | tr "[" "\n" | grep -e "^[sS].*[kK][eE][yY]" | sed -e "s/[sS]\(....\)]^[nN][aA][zZ][wW][aA]=\(.*\)^[uU][aA]=............^[pP][pP][uU][aA]=........^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1   \3 \4 ;\5 \2 @^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/S \1\2S \1   \3 \4 ;\5@/" -e "s/\^.*$/;--------------------------------------------------@;/" | tr "@" "\n" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; VIACCESS Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
tr "\r" " " < $XCAM | tr "\n" "^" | tr "[" "\n" | grep -e "^[vV].*[kK][eE][yY]" | sed -e "s/[vV]\(......\)]^[nN][aA][zZ][wW][aA]=\(.*\)^[sS][nN]=..........^[pP][pP][uU][aA]=........^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1 \3 \4 ;\5 \2 @^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@^p:_/" -e "s/^V \(......\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/V \1\2V \1 \3 \4 ;\5@/" -e "s/\^.*$/;--------------------------------------------------@;/" | tr "@" "\n" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; NAGRA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
tr "\r" " " < $XCAM | tr "\n" "^" | tr "[" "\n" | grep -e "^[nN].*[kK][eE][yY]" | sed -e "s/[nN]\(....\)]^[nN][aA][zZ][wW][aA]=\([^\^]*\)^[vV][eE][rR][iI][fF][yY]=\([^\^]*\)^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1   \4 \5 ;\6 \2 verify=\3@^p:_/" -e "s/^S \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1\2N \1   \3 \4 ;\5@^p:_/" -e "s/^N \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1\2N \1   \3 \4 ;\5@^p:_/" -e "s/^N \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1\2N \1   \3 \4 ;\5@^p:_/" -e "s/^N \(....\)\([^\^]*\)^p:_^[kK][eE][yY]=\(..\) \(................\)\([^\^]*\)/N \1\2N \1   \3 \4 ;\5@/" -e "s/\^.*$/;--------------------------------------------------@;/" | tr "@" "\n" >> $MGCAMDTMP
nagraunhack $MGCAMDTMP $MGCAMD
}

evocamd2mgcamd()
{
echo "; SofTcam.Key generated by dreamconv.sh from Keylist.txt (evocamd)" > $MGCAMDTMP
echo ";" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; IRDETO Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^[Ii]' $EVOCAMD | sed -e 's/^[Ii] \(..\) \(..\) \(................\)\( \?;\?\)\(.*\)/I \1     \2 \3 ; \5/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; SECA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^[Ss]' $EVOCAMD | sed -e 's/^[Ss] \(....\) \(..\) \(................\)\( \?;\?\)\(.*\)/S \1   \2 \3 ; \5/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; VIACCESS Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^[Vs]' $EVOCAMD | sed -e 's/^[Vv] \(......\) \(..\) \(................\)\( \?;\?\)\(.*\)/V \1 \2 \3 ; \5/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; NAGRA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^[Nn]' $EVOCAMD | sed -e 's/^[Nn] \(....\) \(..\) \(................\)\( \?;\?\)\(.*\)/N \1   \2 \3 ; \5/' >> $MGCAMDTMP
cp $MGCAMDTMP $MGCAMD
}

mgcamd2evocamd()
{
echo "; Keylist.txt (evocamd) generated by dreamconv.sh from SoftCam.Key " > $EVOCAMDTMP
echo ";" >> $EVOCAMDTMP
echo ";*************************************************************************" >> $EVOCAMDTMP
echo "; IRDETO Providers and keys" >> $EVOCAMDTMP
echo ";*************************************************************************" >> $EVOCAMDTMP
grep -e '^[Ii]' $MGCAMD | sed -e 's/^[Ii] \(..\)     \(..\) \(................\)\([ ;]*\)/I \1 \2 \3\4/' >> $EVOCAMDTMP
echo ";*************************************************************************" >> $EVOCAMDTMP
echo "; SECA Providers and keys" >> $EVOCAMDTMP
echo ";*************************************************************************" >> $EVOCAMDTMP
grep -e '^[Ss]' $MGCAMD | sed -e 's/^[Ss] \(....\)   \(..\) \(................\)\([ ;]*\)/S \1 \2 \3\4/' >> $EVOCAMDTMP
echo ";*************************************************************************" >> $EVOCAMDTMP
echo "; VIACCESS Providers and keys" >> $EVOCAMDTMP
echo ";*************************************************************************" >> $EVOCAMDTMP
grep -e '^[Vs]' $MGCAMD | sed -e 's/^[Vv] \(......\) \(..\) \(................\)\([ ;]*\)/V \1 \2 \3\4/' >> $EVOCAMDTMP
echo ";*************************************************************************" >> $EVOCAMDTMP
echo "; NAGRA Providers and keys" >> $EVOCAMDTMP
echo ";*************************************************************************" >> $EVOCAMDTMP
grep -e '^[Nn]' $MGCAMD | sed -e 's/^[Nn] \(....\)   \(..\) \(................\)\([ ;]*\)/N \1 \2 \3\4/' >> $EVOCAMDTMP
cp $EVOCAMDTMP $EVOCAMD
}

newcamd2mgcamd()
{
echo "; SoftCam.Key generated by dreamconv.sh from keylist (newcamd)" > $MGCAMDTMP
echo ";" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; IRDETO Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^17..:' $NEWCAMD | sed -e 's/^17..:......:....\(..\)::\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/I 10     \1 \2\3\4\5\6\7\8\9/' -e 's/^\(I 10     .. ................\) \?#\?\(.*\)/\1 ;\2/' >> $MGCAMDTMP 
grep -e '^0600:' $NEWCAMD | sed -e 's/^0600:......:....\(..\)::\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/I 00     \1 \2\3\4\5\6\7\8\9/' -e 's/^\(I 00     .. ................\) \?#\?\(.*\)/\1 ;\2/' >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; SECA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^0100:' $NEWCAMD | sed -e 's/^0100:..\(....\):....\(..\)::\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/S \1   \2 \3\4\5\6\7\8\9/' -e 's/^\(S ....   .. ..............\) \(..\) \?#\?\(.*\)/\1\2 ;\3/' >> $MGCAMDTMP 
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; VIACCESS Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^0500:' $NEWCAMD | sed -e 's/^0500:\(......\):....\(..\)::\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/V \1 \2 \3\4\5\6\7\8\9/' -e 's/^\(V ...... .. ..............\) \(..\) \?#\?\(.*\)/\1\2 ;\3/' >> $MGCAMDTMP 
echo ";*************************************************************************" >> $MGCAMDTMP
echo "; NAGRA Providers and keys" >> $MGCAMDTMP
echo ";*************************************************************************" >> $MGCAMDTMP
grep -e '^1800:' $NEWCAMD | sed -e 's/^1800:......:\(....\)\(..\)::\(..\) \(..\) \(..\) \(..\) \(..\) \(..\) \(..\)/N \1   \2 \3\4\5\6\7\8\9/' -e 's/^\(N ....   .. ..............\) \(..\) \?#\?\(.*\)/\1\2 ;\3/' >> $MGCAMDTMP 
cp $MGCAMDTMP $MGCAMD
}

mgcamd2newcamd()
{
echo "# keylist (newcamd) generated by dreamconv.sh from SoftCam.Key " > $NEWCAMDTMP
echo "#" >> $NEWCAMDTMP
echo "#*************************************************************************" >> $NEWCAMDTMP
echo "# IRDETO Providers and keys" >> $NEWCAMDTMP
echo "#*************************************************************************" >> $NEWCAMDTMP
grep -e '^[Ii] 10' $MGCAMD | sed -e 's/^[Ii] 10     \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/1762:000000:0000\1::\2 \3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(17.*\)p_^ \?[ ;]\?\(.*\)/\1 # \2/' >> $NEWCAMDTMP
grep -e '^[Ii] 00' $MGCAMD | sed -e 's/^[Ii] 00     \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/0600:000000:0000\1::\2 \3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(0600.*\)p_^ \?[ ;]\?\(.*\)/\1 # \2/' >> $NEWCAMDTMP
#echo "#*************************************************************************" >> $NEWCAMDTMP
#echo "# SECA Providers and keys" >> $NEWCAMDTMP
#echo "#*************************************************************************" >> $NEWCAMDTMP
grep -e '^[Ss]' $MGCAMD | sed -e 's/^[Ss] \(....\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/0100:00\1:0000\2::\3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(0100.*\)p_^\(..\) \?[ ;]\?\(.*\)/\1 \2 # \3/' >> $NEWCAMDTMP
echo "#*************************************************************************" >> $NEWCAMDTMP
echo "# VIACCESS Providers and keys" >> $NEWCAMDTMP
echo "#*************************************************************************" >> $NEWCAMDTMP
grep -e '^[Vs]' $MGCAMD | sed -e 's/^[Vv] \(......\) \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/0500:\1:0000\2::\3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(0500.*\)p_^\(..\) \?[ ;]\?\(.*\)/\1 \2 # \3/' >> $NEWCAMDTMP
echo "#*************************************************************************" >> $NEWCAMDTMP
echo "# NAGRA Providers and keys" >> $NEWCAMDTMP
echo "#*************************************************************************" >> $NEWCAMDTMP
grep -e '^[Nn]' $MGCAMD | sed -e 's/^[Nn] \(....\)   \(..\) \(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)/1800:000000:\1\2::\3 \4 \5 \6 \7 \8 \9p_^/' -e 's/^\(1800.*\)p_^\(..\) \?[ ;]\?\(.*\)/\1 \2 # \3/' >> $NEWCAMDTMP
cp $NEWCAMDTMP $NEWCAMD
}

nagrahack()
{
# nagravision hispavision provider id hack
# call nagrahack <scce or gbox nagra keyfile>
  #grep -e '^N: { 70' -e '^N: { 40' -e '^N: { 48' $1 | sed -e 's/^N: { 70/N: { 71/' -e 's/^N: { 48/N: { 49/' -e 's/^N: { 40/N: { 41/' >> $1
  sed -e 's/^N: { 70/N: { 71/' -e 's/^N: { 40/N: { 41/' -e 's/^N: { 48/N: { 49/' -e 's/^N: { 78/N: { 74/' $1 > $GBOXNAGRATMP && cp $GBOXNAGRATMP $1
}

nagraunhack()
{
  sed -e 's/^N 71/N 70/' -e 's/^N 41/N 40/' -e 's/^N 49/N 48/' -e 's/^N 74/N 78/' $1 > $2 && cp $2 $1
}

nagrahackmgcamd()
{
# nagravision hispavision provider id hack
# call nagrahack <mgcamd keyfile>
  ##grep -e '^N 70' -e '^N 40' -e '^N 48' $1 | sed -e 's/^N 70/N 71/' -e 's/^N 40/N 41/' -e 's/^N 48/N 49/' >> $1
  sed -e 's/^N 70/N 71/' -e 's/^N 40/N 41/' -e 's/^N 48/N 49/' -e 's/^N 78/N 74/' $1 > $GBOXNAGRATMP && cp $GBOXNAGRATMP $1
}

help()
{
  echo " "
  echo "This script does tricks with dreambox/dbox2 emu keys."
  echo "Usage: $0 <parameter> "
  echo " "
  echo "Where parameter can be:"
  echo "gbox2romu       - convert gbox files to romu files (Ronalds Emu)"
  echo "gbox2scce       - convert gbox files to scce files (Dr. Matrix)"
  echo "gbox2mgcamd     - convert gbox files to mgcamd (softcam.key file)"
  echo "newcamd2mgcamd  - convert newcamd files to mgcamd (softcam.key file)"
  echo "xcam2mgcamd     - convert xcam file to mgcamd (softcam.key file)"
  echo "evocamd2mgcamd  - convert evocamd file to mgcamd (softcam.key file)"
  echo "mgcamd2gbox     - convert mgcamd (softcam.key file) to gbox files"
  echo "mgcamd2romu     - convert mgcamd (softcam.key file) to romu files"
  echo "mgcamd2scce     - convert mgcamd (softcam.key file) to scce files"
  echo "mgcamd2evocamd  - convert mgcamd (softcam.key file) to evocamd (Keylist.txt file)"
  echo "mgcamd2newcamd  - convert mgcamd (softcam.key file) to newcamd (keylist file)"
  echo "mgcamd2camd3	- convert mgcamd (softcam.key file) to camd3 (camd3.keys file)"
  echo "romu2gbox       - convert romu files to gbox"
  echo "scce2gbox       - convert scce files to gbox"
  echo "scce2mgcamd     - convert scce files to mgcamd (softcam.key file)"
  echo "nagrahackmgcamd - nagra hack for mgcamd (SoftCam.Key) file"
  echo "nagrahackromu   - nagra hack for romu (nagra_keys) file"
  echo "nagrahackscce   - nagra hack for scce (nagra_keys) file"
  echo "nagrahackgbox   - nagra hack for gbox (nagra) file"
  echo " "
  echo "Parameters are case-sensitive (welcome to Linux :)"
}

# main loop

case $1 in
	gbox2romu)
		gbox2scce
		nagrahack $SCCENAGRA
		;;
	romu2gbox)
		scce2gbox
		nagrahack $GBOXNAGRA
		;;
	gbox2scce)
		gbox2scce
		nagrahack $SCCENAGRA
		;;
	scce2gbox)
		scce2gbox
		nagrahack $GBOXNAGRA
		;;
	scce2mgcamd)
		scce2mgcamd
		;;
	mgcamd2scce)
		mgcamd2scce
		nagrahack $SCCENAGRA
		;;
	mgcamd2romu)
		mgcamd2scce
		nagrahack $SCCENAGRA
		;;
	mgcamd2gbox)
		mgcamd2gbox
		nagrahack $GBOXNAGRA
		;;
	mgcamd2newcamd)
		mgcamd2newcamd
		;;
	mgcamd2camd3)
		mgcamd2camd3
		;;
	newcamd2mgcamd)
		newcamd2mgcamd
		;;
	gbox2mgcamd)
		gbox2mgcamd
		;;
	xcam2mgcamd)
		xcam2mgcamd
		;;
	evocamd2mgcamd)
		evocamd2mgcamd
		;;
	mgcamd2evocamd)
		mgcamd2evocamd
		;;
	nagrahackmgcamd)
		nagrahackmgcamd $MGCAMD
		;;
	nagrahackgbox)
		nagrahack $GBOXNAGRA
		;;
	nagrahackromu)
		nagrahack $SCCENAGRA
		;;
	nagrahackscce)
		nagrahack $SCCENAGRA
		;;
	*)
		help
		;;
esac

